#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinSock2.H>
#include <WinSock.H>
#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../../../CSocketServer.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void OnError(CSocketServer *lpCSocketServer, int iClient, int iErrorNumber, const char *sErrorMsg)
{
	if(iClient >= 0)
	{
		printf("Error: %d, Client: %d, Msg: %s\n", iErrorNumber, iClient, sErrorMsg);
	}
	else{
		printf("Error: %d, Msg: %s\n", iErrorNumber, sErrorMsg);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ClientProc(CSocketServer *pSock, int iClient, LPBASICHUNK pChunk)
{
    while(pSock->IsConnected(iClient))
    {
		if(pSock->GetNextClientData(iClient, pChunk))
		{
			printf("Received: [%s] (%db)\n>", pChunk->sBuffer, pChunk->iLength);
		}
	}

	//Unline iClient, the PeerID() returns a a unique ID per connection.
	printf("%d disconnected\n", pSock->PeerID(iClient));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
	CSocketServer Sock;

	printf("Initializing the client.\n");
	if(Sock.Initialize(&ClientProc, &OnError))
	{
		printf("Starting the client.\n");
		if(Sock.Start())
		{
			printf("Connecting to the server.\n");

			int iClient = 0;
			int iBytes = 0;
			int iPackets = 0;

			if(Sock.ConnectAndCreateThread("LocalHost", 1559, &iClient))
			{
				printf("The client is running. Open more clients, then type messages!!\n\n");
				char sBuf[10240];

				printf(">");

				while(Sock.IsConnected(iClient))
				{
					gets_s(sBuf, sizeof(sBuf));
					int iData = strlen(sBuf);
					Sock.SetNextSendData(iClient, sBuf);
					printf("\n>");
				}
			}
			Sock.Stop();
		}
		Sock.Destroy();
	}
	
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
