#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinSock2.H>
#include <WinSock.H>
#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../../../CSocketServer.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void OnError(CSocketServer *lpCSocketServer, int iClient, int iErrorNumber, const char *sErrorMsg)
{
	if(iClient >= 0)
	{
		printf("Error: %d, Client: %d, Msg: %s\n", iErrorNumber, iClient, sErrorMsg);
	}
	else{
		printf("Error: %d, Msg: %s\n", iErrorNumber, sErrorMsg);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
	CSocketServer Sock;

	printf("Initializing the server.\n");
	if(Sock.Initialize(1559, 25, &OnError))
	{
		printf("Starting the server.\n");
		if(Sock.Start())
		{
			printf("The server is running.\n");

			BASICHUNK lChunk;
			if(!Sock.Alloc(&lChunk))
			{
				printf("Failed to allocate RAM for send/recv chunk.\n");
				return 0;
			}

			int iBytes = 0;
			int iPackets = 0;

			for(int iClient = 0; Sock.GetNextClient(&iClient);)
			{
				//If the client is connected.
				if(Sock.GetClientData(iClient, &lChunk))
				{
					iBytes += lChunk.iLength;
					iPackets++;

					printf("Packets: %d, Bytes: %d\r", iPackets, iBytes);

					//Send the received data to all of the other connected clients.
					for(int i3rdParty = 0; i3rdParty < Sock.MaxConnections(); i3rdParty++)
					{
						if(i3rdParty != iClient) //Don't send to the client that sent us the data.
						{
							//Is the client connected?
							if(Sock.IsConnected(i3rdParty))
							{
								//Send the data.
								Sock.SetNextSendData(iClient, i3rdParty, &lChunk);
							}
						}
					}
				}
				Sleep(1); //Save CPU time.
			}

			Sock.Free(&lChunk);
			Sock.Stop();
		}
		Sock.Destroy();
	}

	system("pause");
	
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
