#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinSock2.H>
#include <WinSock.H>
#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../../../CSocketServer.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void OnError(CSocketServer *lpCSocketServer, int iClient, int iErrorNumber, const char *sErrorMsg)
{
	if(iClient >= 0)
	{
		printf("Error: %d, Client: %d, Msg: %s\n", iErrorNumber, iClient, sErrorMsg);
	}
	else{
		printf("Error: %d, Msg: %s\n", iErrorNumber, sErrorMsg);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void ClientProc(CSocketServer *pSock, int iClient, LPBASICHUNK pChunk)
{
    while(pSock->IsConnected(iClient))
    {
		if(pSock->GetNextClientData(iClient, pChunk))
		{
			printf("Received: [%s] (%db)\n", pChunk->sBuffer, pChunk->iLength);
			for(int iPeer = 0; iPeer < pSock->MaxConnections(); iPeer++)
			{
				if(iPeer != iClient) //Don't send date to the client that sent it to us.
				{
					pSock->SetNextSendData(iClient, iPeer, pChunk);
				}
			}
		}
	}

	//Unline iClient, the PeerID() returns a a unique ID per connection.
	printf("%d disconnected\n", pSock->PeerID(iClient));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
	CSocketServer Sock;

	printf("Initializing the server.\n");
	if(Sock.Initialize(1559, 25, &ClientProc, &OnError))
	{
		printf("Starting the server.\n");
		if(Sock.Start())
		{
			printf("The server is running.\n");
			while(Sock.IsActive())
			{
				Sleep(1000);
			}
			Sock.Stop();
		}
		Sock.Destroy();
	}

	system("pause");
	
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
