///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CSocketServer_Receive_Cpp
#define _CSocketServer_Receive_Cpp
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define _WIN32_WINNT 0x0500
#define WIN32_LEAN_AND_MEAN 

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinSock2.H>
#include <WinSock.H>
#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <Time.H>

#include "CSocketServer.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
	Receives data from a remote peer.

	This function should not be called directly.
*/
bool CSocketServer::p_Receive(int iClient)
{
	if(this->CCI[iClient].RecvChunk.iLength > this->p_iPacketBufferSize)
	{
		if(this->CCI[iClient].bPacketMode)
		{
			if(this->p_AnalysePacket(iClient) == SSPACKET_GOOD_PACKET)
			{
				//We are already over the buffer quota and the client has a
				//	full packet in their buffer. No reason to receive any
				//	more data at this point because we are receiving data
				//	faster then it is being process and all we'll do it 
				//	waste RAM.
				return false;
			}
		}
	}

	this->p_RecvChunk.iLength = recv(this->CCI[iClient].Socket,
		this->p_RecvChunk.sBuffer, this->p_RecvChunk.iAlloc, 0);

	if(this->p_RecvChunk.iLength == SOCKET_ERROR)
	{
		this->CCI[iClient].bDisconnect = true;
	}
	else if(this->p_RecvChunk.iLength == 0) // Gracefull disconnect
	{
		this->CCI[iClient].bDisconnect = true;
	}
	else{
		if(this->pOnRecv)
		{
			if(!this->pOnRecv(this, iClient, &this->p_RecvChunk))
			{
				return false;
			}
		}

		int iMemoryRequired = this->CCI[iClient].RecvChunk.iLength + this->p_RecvChunk.iLength;
		if(iMemoryRequired >= this->CCI[iClient].RecvChunk.iAlloc)
		{
			if(!this->ReAlloc(&this->CCI[iClient].RecvChunk, iMemoryRequired + 1))
			{
				return false;
			}
		}

		memcpy_s(this->CCI[iClient].RecvChunk.sBuffer + this->CCI[iClient].RecvChunk.iLength,
			this->CCI[iClient].RecvChunk.iAlloc, this->p_RecvChunk.sBuffer, this->p_RecvChunk.iLength);

		this->CCI[iClient].RecvChunk.iLength += this->p_RecvChunk.iLength;

		if(this->CCI[iClient].bPacketMode)
		{
			if(this->p_AnalysePacket(iClient) < 0)
			{
				this->CCI[iClient].bDisconnect = true;
				return this->p_ThrowError(1, iClient);
			}
		}

		time(&this->CCI[iClient].ttLastActivity);

		return true;
	}

	return false;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
