///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CSocketServer_Send_Cpp
#define _CSocketServer_Send_Cpp
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define _WIN32_WINNT 0x0500
#define WIN32_LEAN_AND_MEAN 

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <WinSock2.H>
#include <WinSock.H>
#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <Time.H>

#include "CSocketServer.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
	Sends data to a remote peer.

	This function should not be called directly.
*/
bool CSocketServer::p_Send(int iClient)
{
	if(this->CCI[iClient].SendChunk.iLength > 0)
	{
		if(this->pOnSend)
		{
			if(!this->pOnSend(this, iClient, &this->CCI[iClient].SendChunk))
			{
				return false; //All is well.
			}
		}

		if(this->IsConnected(iClient))
		{
			this->p_Packetize(iClient);

			int iResult = send(this->CCI[iClient].Socket,
				this->p_SendChunk.sBuffer, this->p_SendChunk.iLength, 0);

			if(iResult == SOCKET_ERROR)
			{
				int iLastError = WSAGetLastError();
				if(iLastError == WSAEWOULDBLOCK || iLastError == WSAEINPROGRESS)
				{
					return false;
				}
				else if(iLastError == WSAENOBUFS)
				{
					this->p_ThrowError(iClient, 11);
					this->CCI[iClient].bDisconnect = true;
				}
				else{
					this->CCI[iClient].bDisconnect = true;
				}
			}
			else if(iResult == 0)
			{
				this->CCI[iClient].bDisconnect = true;
			}
			else if(iResult != this->p_SendChunk.iLength)
			{
				this->p_ThrowError(iClient, 11);
				this->CCI[iClient].bDisconnect = true;
			}
			else{
				this->CCI[iClient].SendChunk.iLength = 0; //All is well.
				time(&this->CCI[iClient].ttLastActivity);
				return true;
			}
		}
	}

	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
